Prov.Visualization<-function(recipe,data,graph,type){
  plots <- strsplit(recipe$Analysis$Workflow$Visualization$plots, ", | |,")[[1]]
  i<-switch(type,
            "fcst"="parentnodename_fcst",
            "hcst"="parentnodename_hcst")
  parentnodename<-graph$parentnodename[[i]]
  graph<-graph$graph

  if ("skill_metrics" %in% plots) {
    measure <- unlist(strsplit(recipe$Analysis$Workflow$Skill$metric, " "))
    nodenames<-list()
    for (names in measure){
        names<-tolower(names)
        graph.nodename <- paste0("Graph_",type, "_",names)
        label.name<-getSkillScoreLabel(names)

        graph <- add_vertices(graph,
                              nv = 1,
                              name = graph.nodename,
                              label=paste0(label.name," ", "Graphical representation"),
                              className = "go:Map")

        graph <- add_edges(graph, 
                           c(getNodeIndexbyName(graph, paste0("Metrics_", type, "_",names) ),
                             getNodeIndexbyName(graph, graph.nodename)),
                           label = "go:hadGraphicalRepresentation")     
        nodenames<-append(nodenames,list(graph.nodename))

    }
  }
    
  if(!is.null(data$fcst)){
    if("forecast_ensemble_mean" %in% plots){
      graph.nodename<-paste0("Graph_","forecast_ensemble")
      graph <- add_vertices(graph,
                            nv = 1,
                            name = graph.nodename,
                            label=paste0("Forecast Ensemble","Graphical representation"),
                            className = "go:Map")

      if("Anomalies_fcst" %in% V(graph)$name){
        graph <- add_edges(graph, 
                          c(getNodeIndexbyName(graph, "Anomalies_fcst"),
                            getNodeIndexbyName(graph, graph.nodename)),
                          label = "go:hadGraphicalRepresentation")  

      }
      
      nodenames<-append(nodenames, list(graph.nodename))
      
    }
  }
 
 return(list("graph"=graph,"parentnodename"=parentnodename, "nodenames"=nodenames))

}
